> ## Documentation Index
> Fetch the complete documentation index at: https://www.courier.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List versions of a journey-scoped notification template

> GET the published versions of a journey-scoped notification template, ordered most recent first, by journey template ID and notification ID.



## OpenAPI

````yaml /openapi-specs/openapi.documented.yml get /journeys/{templateId}/templates/{notificationId}/versions
openapi: 3.0.1
info:
  title: Courier
  description: The Courier REST API for sending and managing notifications across channels.
  version: 0.0.1
servers:
  - url: https://api.courier.com
    description: Production
security: []
paths:
  /journeys/{templateId}/templates/{notificationId}/versions:
    get:
      tags:
        - Journeys
      summary: List versions of a journey-scoped notification template
      description: >-
        GET the published versions of a journey-scoped notification template,
        ordered most recent first, by journey template ID and notification ID.
      operationId: journeys_listTemplateVersions
      parameters:
        - in: path
          name: templateId
          schema:
            type: string
            minLength: 1
          required: true
          description: Journey id
        - in: path
          name: notificationId
          schema:
            type: string
            minLength: 1
          required: true
          description: Notification template id
      responses:
        '200':
          description: Notification template version list
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotificationTemplateVersionListResponse'
              examples:
                Example1:
                  summary: Two versions
                  value:
                    versions:
                      - version: v2
                        created: 1715000400000
                        creator: user-1
                      - version: v1
                        created: 1715000200000
                        creator: user-1
                    paging:
                      more: false
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadRequest'
              examples:
                Example:
                  value:
                    message: Example message text
                    type: invalid_request_error
        '404':
          description: Not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFound'
              examples:
                Example:
                  value:
                    message: Example message text
                    type: invalid_request_error
      security:
        - BearerAuth: []
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Courier from '@trycourier/courier';


            const client = new Courier({
              apiKey: process.env['COURIER_API_KEY'], // This is the default and can be omitted
            });


            const notificationTemplateVersionListResponse = await
            client.journeys.templates.listVersions('x', {
              templateId: 'x',
            });


            console.log(notificationTemplateVersionListResponse.paging);
        - lang: Python
          source: >-
            import os

            from courier import Courier


            client = Courier(
                api_key=os.environ.get("COURIER_API_KEY"),  # This is the default and can be omitted
            )

            notification_template_version_list_response =
            client.journeys.templates.list_versions(
                notification_id="x",
                template_id="x",
            )

            print(notification_template_version_list_response.paging)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/trycourier/courier-go\"\n\t\"github.com/trycourier/courier-go/option\"\n)\n\nfunc main() {\n\tclient := courier.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tnotificationTemplateVersionListResponse, err := client.Journeys.Templates.ListVersions(\n\t\tcontext.TODO(),\n\t\t\"x\",\n\t\tcourier.JourneyTemplateListVersionsParams{\n\t\t\tTemplateID: \"x\",\n\t\t},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", notificationTemplateVersionListResponse.Paging)\n}\n"
        - lang: Java
          source: >-
            package com.courier.example;


            import com.courier.client.CourierClient;

            import com.courier.client.okhttp.CourierOkHttpClient;

            import
            com.courier.models.journeys.templates.TemplateListVersionsParams;

            import
            com.courier.models.notifications.NotificationTemplateVersionListResponse;


            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    CourierClient client = CourierOkHttpClient.fromEnv();

                    TemplateListVersionsParams params = TemplateListVersionsParams.builder()
                        .templateId("x")
                        .notificationId("x")
                        .build();
                    NotificationTemplateVersionListResponse notificationTemplateVersionListResponse = client.journeys().templates().listVersions(params);
                }
            }
        - lang: Ruby
          source: >-
            require "courier"


            courier = Courier::Client.new(api_key: "My API Key")


            notification_template_version_list_response =
            courier.journeys.templates.list_versions("x", template_id: "x")


            puts(notification_template_version_list_response)
        - lang: PHP
          source: >-
            <?php


            require_once dirname(__DIR__) . '/vendor/autoload.php';


            use Courier\Client;

            use Courier\Core\Exceptions\APIException;


            $client = new Client(apiKey: getenv('COURIER_API_KEY') ?: 'My API
            Key');


            try {
              $notificationTemplateVersionListResponse = $client
                ->journeys
                ->templates
                ->listVersions('x', templateID: 'x');

              var_dump($notificationTemplateVersionListResponse);
            } catch (APIException $e) {
              echo $e->getMessage();
            }
        - lang: C#
          source: >-
            using System;

            using TryCourier;

            using TryCourier.Models.Journeys.Templates;


            CourierClient client = new();


            TemplateListVersionsParams parameters = new()

            {
                TemplateID = "x",
                NotificationID = "x",
            };


            var notificationTemplateVersionListResponse = await
            client.Journeys.Templates.ListVersions(parameters);


            Console.WriteLine(notificationTemplateVersionListResponse);
        - lang: CLI
          source: |-
            courier journeys:templates list-versions \
              --api-key 'My API Key' \
              --template-id x \
              --notification-id x
components:
  schemas:
    NotificationTemplateVersionListResponse:
      title: NotificationTemplateVersionListResponse
      type: object
      properties:
        versions:
          type: array
          items:
            $ref: '#/components/schemas/VersionNode'
        paging:
          $ref: '#/components/schemas/Paging'
      required:
        - versions
        - paging
    BadRequest:
      title: BadRequest
      type: object
      properties:
        type:
          type: string
          enum:
            - invalid_request_error
      required:
        - type
      allOf:
        - $ref: '#/components/schemas/BaseError'
    NotFound:
      title: NotFound
      type: object
      properties:
        type:
          type: string
          enum:
            - invalid_request_error
      required:
        - type
      allOf:
        - $ref: '#/components/schemas/BaseError'
    VersionNode:
      title: VersionNode
      type: object
      description: A version entry for a notification template.
      properties:
        version:
          type: string
          description: >-
            Version identifier. One of "draft", "published:vNNN" (current
            published version), or "vNNN" (historical version).
        created:
          type: integer
          format: int64
          description: Epoch milliseconds when this version was created.
        creator:
          type: string
          description: User ID of the version creator.
        has_changes:
          type: boolean
          description: >-
            Whether the draft has unpublished changes. Only present on the draft
            version.
      required:
        - version
        - created
        - creator
    Paging:
      title: Paging
      type: object
      properties:
        cursor:
          type: string
          nullable: true
        more:
          type: boolean
      required:
        - more
    BaseError:
      title: BaseError
      type: object
      properties:
        message:
          type: string
          description: A message describing the error that occurred.
      required:
        - message
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````